/* Generated automatically by the program `genpeep'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "tree.h"
#include "rtl.h"
#include "insn-config.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "regs.h"
#include "output.h"
#include "recog.h"
#include "except.h"
#include "diagnostic-core.h"
#include "flags.h"
#include "tm-constrs.h"

extern rtx peep_operand[];

#define operands peep_operand

rtx_insn *
peephole (rtx_insn *ins1)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;
  rtx x ATTRIBUTE_UNUSED, pat ATTRIBUTE_UNUSED;

  if (NEXT_INSN (ins1)
      && BARRIER_P (NEXT_INSN (ins1)))
    return 0;

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2982;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2982;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2982;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2982; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2982;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2982;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L2982;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2982;
  if (GET_MODE (x) != V16QImode) goto L2982;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2982;
  if (GET_MODE (x) != SImode) goto L2982;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2982;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2982;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L2982;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2982;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2982:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2983;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2983;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2983;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2983; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2983;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2983;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L2983;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2983;
  if (GET_MODE (x) != V16QImode) goto L2983;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2983;
  if (GET_MODE (x) != DImode) goto L2983;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2983;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2983;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L2983;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2983;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2983:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2984;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2984;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2984;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2984; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2984;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2984;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L2984;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2984;
  if (GET_MODE (x) != V8HImode) goto L2984;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2984;
  if (GET_MODE (x) != SImode) goto L2984;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2984;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2984;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L2984;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2984;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2984:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2985;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2985;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2985;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2985; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2985;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2985;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L2985;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2985;
  if (GET_MODE (x) != V8HImode) goto L2985;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2985;
  if (GET_MODE (x) != DImode) goto L2985;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2985;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2985;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L2985;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2985;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2985:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2986;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2986;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2986;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2986; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2986;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2986;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L2986;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2986;
  if (GET_MODE (x) != V4SImode) goto L2986;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2986;
  if (GET_MODE (x) != SImode) goto L2986;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2986;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2986;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L2986;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2986;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2986:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2987;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2987;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2987;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2987; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2987;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2987;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L2987;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2987;
  if (GET_MODE (x) != V4SImode) goto L2987;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2987;
  if (GET_MODE (x) != DImode) goto L2987;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2987;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2987;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L2987;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2987;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2987:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2988;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2988;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2988;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2988; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2988;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2988;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L2988;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2988;
  if (GET_MODE (x) != V2DImode) goto L2988;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2988;
  if (GET_MODE (x) != SImode) goto L2988;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2988;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2988;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L2988;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2988;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2988:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2989;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2989;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2989;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2989; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2989;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2989;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L2989;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2989;
  if (GET_MODE (x) != V2DImode) goto L2989;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2989;
  if (GET_MODE (x) != DImode) goto L2989;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2989;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2989;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L2989;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2989;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2989:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2990;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2990;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2990;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2990; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2990;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2990;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L2990;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2990;
  if (GET_MODE (x) != V4SFmode) goto L2990;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2990;
  if (GET_MODE (x) != SImode) goto L2990;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2990;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2990;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L2990;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2990;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2990:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2991;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2991;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2991;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2991; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2991;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2991;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L2991;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2991;
  if (GET_MODE (x) != V4SFmode) goto L2991;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2991;
  if (GET_MODE (x) != DImode) goto L2991;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2991;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2991;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L2991;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2991;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2991:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2992;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2992;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2992;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2992; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2992;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2992;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L2992;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2992;
  if (GET_MODE (x) != V2DFmode) goto L2992;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2992;
  if (GET_MODE (x) != SImode) goto L2992;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2992;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2992;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L2992;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2992;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2992:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2993;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2993;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2993;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2993; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2993;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2993;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L2993;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2993;
  if (GET_MODE (x) != V2DFmode) goto L2993;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2993;
  if (GET_MODE (x) != DImode) goto L2993;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2993;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2993;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L2993;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2993;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2993:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2994;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2994;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2994;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2994; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2994;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2994;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L2994;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2994;
  if (GET_MODE (x) != V1TImode) goto L2994;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2994;
  if (GET_MODE (x) != SImode) goto L2994;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2994;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2994;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L2994;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2994;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2994:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2995;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2995;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2995;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2995; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2995;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2995;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L2995;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2995;
  if (GET_MODE (x) != V1TImode) goto L2995;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2995;
  if (GET_MODE (x) != DImode) goto L2995;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2995;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2995;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L2995;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2995;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2995:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2996;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2996;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2996;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2996; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2996;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2996;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L2996;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2996;
  if (GET_MODE (x) != KFmode) goto L2996;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2996;
  if (GET_MODE (x) != SImode) goto L2996;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2996;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2996;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L2996;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2996;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2996:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2997;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2997;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2997;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2997; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2997;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2997;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L2997;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2997;
  if (GET_MODE (x) != KFmode) goto L2997;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2997;
  if (GET_MODE (x) != DImode) goto L2997;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2997;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2997;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L2997;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2997;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2997:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2998;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L2998;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L2998;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2998; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2998;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2998;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L2998;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2998;
  if (GET_MODE (x) != TFmode) goto L2998;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2998;
  if (GET_MODE (x) != SImode) goto L2998;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2998;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L2998;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L2998;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2998;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2998:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2999;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L2999;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L2999;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L2999; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L2999;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L2999;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L2999;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L2999;
  if (GET_MODE (x) != TFmode) goto L2999;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L2999;
  if (GET_MODE (x) != DImode) goto L2999;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L2999;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L2999;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L2999;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 2999;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L2999:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3000;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3000;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3000;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3000; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3000;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3000;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L3000;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3000;
  if (GET_MODE (x) != TImode) goto L3000;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3000;
  if (GET_MODE (x) != SImode) goto L3000;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3000;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3000;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3000;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3000;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3000:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3001;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3001;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3001;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3001; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3001;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3001;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L3001;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3001;
  if (GET_MODE (x) != TImode) goto L3001;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3001;
  if (GET_MODE (x) != DImode) goto L3001;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  if (!rtx_equal_p (operands[0], x)) goto L3001;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3001;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3001;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3001;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3001:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3002;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3002;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3002;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3002; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3002;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3002;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L3002;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3002;
  if (GET_MODE (x) != V16QImode) goto L3002;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3002;
  if (GET_MODE (x) != SImode) goto L3002;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3002;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3002;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3002;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3002;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3002:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3003;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3003;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3003;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3003; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3003;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3003;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V16QImode)) goto L3003;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3003;
  if (GET_MODE (x) != V16QImode) goto L3003;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3003;
  if (GET_MODE (x) != DImode) goto L3003;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3003;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3003;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3003;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3003;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3003:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3004;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3004;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3004;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3004; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3004;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3004;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L3004;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3004;
  if (GET_MODE (x) != V8HImode) goto L3004;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3004;
  if (GET_MODE (x) != SImode) goto L3004;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3004;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3004;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3004;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3004;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3004:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3005;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3005;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3005;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3005; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3005;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3005;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V8HImode)) goto L3005;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3005;
  if (GET_MODE (x) != V8HImode) goto L3005;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3005;
  if (GET_MODE (x) != DImode) goto L3005;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3005;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3005;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3005;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3005;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3005:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3006;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3006;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3006;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3006; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3006;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3006;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L3006;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3006;
  if (GET_MODE (x) != V4SImode) goto L3006;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3006;
  if (GET_MODE (x) != SImode) goto L3006;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3006;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3006;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3006;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3006;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3006:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3007;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3007;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3007;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3007; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3007;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3007;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SImode)) goto L3007;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3007;
  if (GET_MODE (x) != V4SImode) goto L3007;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3007;
  if (GET_MODE (x) != DImode) goto L3007;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3007;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3007;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3007;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3007;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3007:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3008;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3008;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3008;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3008; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3008;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3008;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L3008;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3008;
  if (GET_MODE (x) != V2DImode) goto L3008;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3008;
  if (GET_MODE (x) != SImode) goto L3008;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3008;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3008;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3008;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3008;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3008:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3009;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3009;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3009;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3009; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3009;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3009;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DImode)) goto L3009;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3009;
  if (GET_MODE (x) != V2DImode) goto L3009;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3009;
  if (GET_MODE (x) != DImode) goto L3009;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3009;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3009;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3009;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3009;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3009:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3010;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3010;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3010;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3010; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3010;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3010;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L3010;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3010;
  if (GET_MODE (x) != V4SFmode) goto L3010;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3010;
  if (GET_MODE (x) != SImode) goto L3010;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3010;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3010;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3010;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3010;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3010:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3011;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3011;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3011;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3011; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3011;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3011;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V4SFmode)) goto L3011;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3011;
  if (GET_MODE (x) != V4SFmode) goto L3011;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3011;
  if (GET_MODE (x) != DImode) goto L3011;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3011;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3011;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3011;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3011;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3011:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3012;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3012;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3012;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3012; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3012;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3012;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L3012;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3012;
  if (GET_MODE (x) != V2DFmode) goto L3012;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3012;
  if (GET_MODE (x) != SImode) goto L3012;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3012;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3012;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3012;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3012;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3012:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3013;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3013;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3013;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3013; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3013;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3013;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V2DFmode)) goto L3013;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3013;
  if (GET_MODE (x) != V2DFmode) goto L3013;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3013;
  if (GET_MODE (x) != DImode) goto L3013;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3013;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3013;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3013;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3013;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3013:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3014;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3014;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3014;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3014; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3014;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3014;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L3014;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3014;
  if (GET_MODE (x) != V1TImode) goto L3014;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3014;
  if (GET_MODE (x) != SImode) goto L3014;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3014;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3014;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3014;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3014;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3014:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3015;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3015;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3015;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3015; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3015;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3015;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, V1TImode)) goto L3015;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3015;
  if (GET_MODE (x) != V1TImode) goto L3015;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3015;
  if (GET_MODE (x) != DImode) goto L3015;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3015;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3015;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3015;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3015;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3015:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3016;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3016;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3016;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3016; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3016;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3016;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L3016;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3016;
  if (GET_MODE (x) != KFmode) goto L3016;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3016;
  if (GET_MODE (x) != SImode) goto L3016;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3016;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3016;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L3016;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3016;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3016:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3017;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3017;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3017;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3017; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3017;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3017;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, KFmode)) goto L3017;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3017;
  if (GET_MODE (x) != KFmode) goto L3017;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3017;
  if (GET_MODE (x) != DImode) goto L3017;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3017;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3017;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (KFmode))) && (FLOAT128_VECTOR_P (KFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L3017;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3017;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3017:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3018;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3018;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3018;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3018; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3018;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3018;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L3018;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3018;
  if (GET_MODE (x) != TFmode) goto L3018;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3018;
  if (GET_MODE (x) != SImode) goto L3018;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3018;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3018;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_32BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_32BIT)) && (TARGET_32BIT)))) goto L3018;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3018;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3018:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3019;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3019;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3019;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3019; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3019;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3019;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TFmode)) goto L3019;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3019;
  if (GET_MODE (x) != TFmode) goto L3019;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3019;
  if (GET_MODE (x) != DImode) goto L3019;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3019;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3019;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (((((TARGET_64BIT) && (FLOAT128_VECTOR_P (TFmode))) && (FLOAT128_VECTOR_P (TFmode))) && (TARGET_64BIT)) && (TARGET_64BIT)))) goto L3019;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3019;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3019:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3020;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, SImode)) goto L3020;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, SImode)) goto L3020;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3020; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3020;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3020;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L3020;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3020;
  if (GET_MODE (x) != TImode) goto L3020;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3020;
  if (GET_MODE (x) != SImode) goto L3020;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, SImode)) goto L3020;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3020;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_32BIT))) goto L3020;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3020;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3020:

  insn = ins1;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3021;
  x = XEXP (pat, 0);
  operands[0] = x;
  if (! base_reg_operand (x, DImode)) goto L3021;
  x = XEXP (pat, 1);
  operands[1] = x;
  if (! short_cint_operand (x, DImode)) goto L3021;
  do { insn = NEXT_INSN (insn);
       if (insn == 0) goto L3021; }
  while (NOTE_P (insn)
	 || (NONJUMP_INSN_P (insn)
	     && (GET_CODE (PATTERN (insn)) == USE
		 || GET_CODE (PATTERN (insn)) == CLOBBER)));
  if (LABEL_P (insn)
      || BARRIER_P (insn))
    goto L3021;
  pat = PATTERN (insn);
  x = pat;
  if (GET_CODE (x) != SET) goto L3021;
  x = XEXP (pat, 0);
  operands[2] = x;
  if (! vsx_register_operand (x, TImode)) goto L3021;
  x = XEXP (pat, 1);
  if (GET_CODE (x) != MEM) goto L3021;
  if (GET_MODE (x) != TImode) goto L3021;
  x = XEXP (XEXP (pat, 1), 0);
  if (GET_CODE (x) != PLUS) goto L3021;
  if (GET_MODE (x) != DImode) goto L3021;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 0);
  operands[3] = x;
  if (! int_reg_operand (x, DImode)) goto L3021;
  x = XEXP (XEXP (XEXP (pat, 1), 0), 1);
  if (!rtx_equal_p (operands[0], x)) goto L3021;
  if (! ((TARGET_VSX && TARGET_P8_FUSION && !TARGET_P9_VECTOR) && (TARGET_64BIT))) goto L3021;
  PATTERN (ins1) = gen_rtx_PARALLEL (VOIDmode, gen_rtvec_v (4, operands));
  INSN_CODE (ins1) = 3021;
  delete_for_peephole (NEXT_INSN (ins1), insn);
  return NEXT_INSN (insn);
 L3021:

  return 0;
}

rtx peep_operand[4];
